package hpdos.handler;

import hpdos.grpc.Ack;
import hpdos.grpc.Nack;
import hpdos.grpc.Request;
import hpdos.grpc.Response;
import hpdos.lib.StorageModel;
import hpdos.lib.StorageService;
import hpdos.message.MessageConstants;
import hpdos.message.ResponseBuilder;

public class IOHandler {
    StorageService storageService;
    public IOHandler(StorageService storageService) {
        this.storageService = storageService;
    }

    public Response create(Request request) {
        Ack ack = null; Nack nack = null;
        StorageModel blob = new StorageModel(
                MessageConstants.INIT_VERSION,
                request.getDataSize(),
                request.getKey(),
                request.getAccessType(),
                request.getClientID(),
                request.getValue());
        boolean status = storageService.create(request.getKey(), blob);
        if (status) {
            ack = ResponseBuilder.buildAck(MessageConstants.INIT_VERSION,
                    blob.getDataSize(),
                    blob.getKey(),
                    blob.getCrc(),
                    blob.getValue());
        }
        else {
            nack = ResponseBuilder.buildNack(MessageConstants.INVALID_VERSION,
                    MessageConstants.STATUS_REPLICATE_FAILED,
                    request.getKey());
        }

        return ResponseBuilder.buildResponsePacket(
                MessageConstants.METADATA_CREATE,
                ack, nack);
    }

    public Response update(Request request) {
        return null;
    }

    public Response delete(Request request) {
        return null;
    }
}
